
#pragma once

#ifdef _DEBUG

// Support for variadic macros was introduced in Visual C++ 2005.
#if defined(_MSC_VER) && _MSC_VER >= 1400 // 1400 = VC++ 8.0 - .Net 2005 
#define CPTRACE( file, var, args... )				\
	CCPTrace clsTrace(file);						\
	if( clsTrace.Function1(file) )					\
	{												\
		clsTrace.Function2( var, __VA_ARGS__ );		\
	}
#else									 // All other flavors of VC++ 
#define CPTRACE( file, var )						\
	CCPTrace clsTrace(file);						\
	if( clsTrace.Function1(file) )					\
	{												\
		clsTrace.Function2( var );					\
	}
#endif

#else // #ifdef _DEBUG

// do nothing in release
#if defined(_MSC_VER) && _MSC_VER >= 1400 // 1400 = VC++ 8.0 - .Net 2005 
#define CPTRACE( file, var, args... )
#else									 // All other flavors of VC++ 
#define CPTRACE( file, var )						
#endif

#endif // #ifdef _DEBUG

#define CPTRACE_API __declspec(dllimport)

class CPTRACE_API CCPTrace
{
public:
	CCPTrace(LPCTSTR lpFile);
	void Function2( LPCTSTR lpszFormat, ... );
	int Function1( LPCTSTR lpFile );

};
